// Copyright (C) 2020, Jakob Wakeling
// MIT Licence

#ifndef ESH_UTIL_OPTGET_H_ZPCLTG8D
#define ESH_UTIL_OPTGET_H_ZPCLTG8D

#define ARG_NUL 0
#define ARG_REQ 1
#define ARG_OPT 2

struct lop {
	char *str;
	int arg, val;
};

struct opt {
	int ind, opt, pos, nop;
	char *arg, *lop, *str;
	struct lop *lops;
};

extern const struct opt OPTGET_INIT;

extern int optget(struct opt *opt, char *av[], int flags);

#endif // ESH_UTIL_OPTGET_H_ZPCLTG8D
